# coding: utf-8

# flake8: noqa

"""
    Opportify Insights API

    ## Overview  The **Opportify Insights API** provides access to a powerful and up-to-date platform. With advanced data warehousing and AI-driven capabilities, this API is designed to empower your business to make informed, data-driven decisions and effectively assess potential risks.  ### Base URL Use the following base URL for all API requests:  ```plaintext https://api.opportify.ai/insights/v1/<service>/<endpoint> ```  ### Features - [**Email Insights:**](/docs/api-reference/email-insights)   - Validate email syntax.   - Identify email types (free, disposable, corporate or unknown).   - Real time verifications:     - Reachable: Confirms if the email domain has valid MX DNS records using DNS lookup.     - Deliverable: Simulates an SMTP handshake to check if the email address exists and is deliverable.     - Catch-All: Detects if the domain accepts all emails (catch-all configuration).   - Intelligent Error Correction: Automatically corrects well-known misspelled email addresses.   - Risk Report: Provides an AI-driven normalized score (200-1000) to evaluate email risk, using predefined thresholds.      [Access Documentation >>](/docs/api-reference/email-insights)  - [**IP Insights:**](/docs/api-reference/ip-insights)   - Connection types: Detects connection types such as `wired`, `mobile`, `enterprise`, `satellite`, `VPN`, `cloud-provider`, `open-proxy`, or `Tor`.   - Geo location: Delivers detailed insights such as country, city, timezone, language preferences, and additional location-based information to enhance regional understanding.   - WHOIS: Provides main details including RIR, ASN, organization, and abuse/admin/technical contacts.   - Trusted Provider Recognition: Identifies if the IP is part of a known trusted provider (e.g., ZTNA - Zero Trust Network Access).   - Blocklist Reports: Retrieves up-to-date blocklist statuses, active reports, and the latest detections.   - Risk Report: Delivers an AI-driven normalized score (200-1000) to evaluate IP risk, supported by predefined thresholds.    [Access Documentation >>](/docs/api-reference/ip-insights)  ### Authentication & Security - **API Key:** Access to the API requires an API key, which must be included in the request headers. Businesses can generate unlimited API keys directly from their account, offering flexibility and ease of use.  - **ACL Rules:** Enhance security with Access Control Lists (ACL), allowing you to restrict API access from specific IP addresses or ranges. This feature provides an additional layer of protection by ensuring only authorized IPs can interact with the API. - **No Query Parameters:** As a precautionary measure, our API avoids the use of query parameters for all operations, including authentication and handling Personally Identifiable Information (PII). This approach minimizes security risks by preventing sensitive data from being exposed in access logs, browser history, cached URLs, debugging tools, or inadvertently shared URLs. All sensitive information is securely transmitted through headers or the request body. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from openapi_client.api.email_insights_api import EmailInsightsApi
from openapi_client.api.ip_insights_api import IPInsightsApi

# import ApiClient
from openapi_client.api_response import ApiResponse
from openapi_client.api_client import ApiClient
from openapi_client.configuration import Configuration
from openapi_client.exceptions import OpenApiException
from openapi_client.exceptions import ApiTypeError
from openapi_client.exceptions import ApiValueError
from openapi_client.exceptions import ApiKeyError
from openapi_client.exceptions import ApiAttributeError
from openapi_client.exceptions import ApiException

# import models into sdk package
from openapi_client.models.abuse_contact import AbuseContact
from openapi_client.models.admin_contact import AdminContact
from openapi_client.models.analyze_email200_response import AnalyzeEmail200Response
from openapi_client.models.analyze_email400_response import AnalyzeEmail400Response
from openapi_client.models.analyze_email400_response_error import AnalyzeEmail400ResponseError
from openapi_client.models.analyze_email500_response import AnalyzeEmail500Response
from openapi_client.models.analyze_email500_response_error import AnalyzeEmail500ResponseError
from openapi_client.models.analyze_email_request import AnalyzeEmailRequest
from openapi_client.models.analyze_ip200_response import AnalyzeIp200Response
from openapi_client.models.analyze_ip400_response import AnalyzeIp400Response
from openapi_client.models.analyze_ip400_response_error import AnalyzeIp400ResponseError
from openapi_client.models.analyze_ip404_response import AnalyzeIp404Response
from openapi_client.models.analyze_ip500_response import AnalyzeIp500Response
from openapi_client.models.analyze_ip_request import AnalyzeIpRequest
from openapi_client.models.asn import Asn
from openapi_client.models.block_listed import BlockListed
from openapi_client.models.email_dns import EmailDNS
from openapi_client.models.geo import Geo
from openapi_client.models.internalerror import INTERNALERROR
from openapi_client.models.invalidemail import INVALIDEMAIL
from openapi_client.models.ipvalidationfailed import IPVALIDATIONFAILED
from openapi_client.models.malformedrequest import MALFORMEDREQUEST
from openapi_client.models.malformedrequest1 import MALFORMEDREQUEST1
from openapi_client.models.notfound import NOTFOUND
from openapi_client.models.organization import Organization
from openapi_client.models.risk_report import RiskReport
from openapi_client.models.tech_contact import TechContact
from openapi_client.models.trusted_provider import TrustedProvider
from openapi_client.models.whois import Whois
